﻿'Imports Microsoft.Office.Interop
Imports System.IO

Public Class Form1

    Private Sub BtnConvert_Click(sender As Object, e As EventArgs) Handles BtnConvert.Click

        Dim XL As Object

        Dim i As Integer
        Dim ii As Integer
        Dim j As Integer

        Dim SN As Integer

        Dim LC As Integer
        Dim SC As Integer

        Dim SR As String
        Dim NF As String
        Dim ExcelFileName As String

        Dim NF_Array() As String
        Dim NF_OK As Boolean

        Erase NF_Array

        Dim TextKeys() As String
        Dim bDelete As Boolean

        ' 選択チェック
        If ListBoxFiles.SelectedItems.Count = 0 Then
            MsgBox("１つ以上のエクセルファイルを指定してください", vbInformation + vbOKOnly, "注意")
            Exit Sub
        End If

        ' Excelを起動する
        'XL = New Excel.Application
        Try
            XL = CreateObject("Excel.Application")
        Catch ex As Exception
            MsgBox("Excelの起動に失敗しました" & vbCrLf & "処理を中断します", vbExclamation + vbOKOnly, "エラー")
            Exit Sub
        End Try

        TextKey.Text = Trim(TextKey.Text)

        With XL
            ' 動きが見えるよう、表示する
            .Visible = True

            ' Book1(統合先)を作成
            .WorkBooks.Add()

            ' Book1 のシートを１枚にする
            SN = .WorkBooks(1).Sheets.Count
            For i = 1 To SN - 1
                .DisplayAlerts = False
                .WorkBooks(1).Worksheets(2).Delete()
                .DisplayAlerts = True
            Next
            ' 残った１ページ目の名前を普通付けない名前に変更する
            .WorkBooks(1).Worksheets(1).Name = "_amnesia_temp-sheet_name_"

            ' 選択したファイルをループする
            LC = ListBoxFiles.SelectedItems.Count
            For SC = 1 To LC
                ' コピー元のファイルを開く
                ExcelFileName = ListBoxFiles.SelectedItems(SC - 1)
                .WorkBooks.Open(ExcelFileName)

                ' コピー元ファイルのシートの全てを処理する
                SN = .WorkBooks(.WorkBooks.count).Sheets.Count
                For i = 1 To SN

                    'シート名が、指定のキーワードなら、コピーしない
                    TextKeys = Split(TextKey.Text, ":")
                    If ChkDeleteSheetName.Checked And TextKey.Text <> "" Then
                        bDelete = False
                        For ii = 0 To UBound(TextKeys)
                            If UCase(.WorkBooks(.WorkBooks.Count).Sheets(i).Name) = UCase(TextKeys(ii)) Then
                                bDelete = True
                                Exit For
                            End If
                        Next
                        ' コピーしない(名前マッチページのスキップ)
                        If bDelete Then Continue For
                    End If

                    If ChkDeleteEmptySheet.Checked Then
                        ' 空シートの判断
                        SR = .WorkBooks(.WorkBooks.Count).Sheets(i).UsedRange.Cells.Address
                        If SR = "$A$1" Or SR = "" Then
                            If .WorkBooks(.WorkBooks.Count).Sheets(i).Range("A1").formula = "" Then
                                ' コピーしない(空ページのスキップ)
                                Continue For
                            End If
                        End If
                    End If

                    ' コピーの実施(最終ページの後ろに追加する)
                    .WorkBooks(.WorkBooks.Count).Sheets(i).Copy(After:=.WorkBooks(1).Sheets(.WorkBooks(1).Sheets.Count))
                    ' シート名の変更処理
                    If ChkSheetNameStyle.Checked Then
                        ' 新しいシート名を作成する
                        NF = Path.GetFileNameWithoutExtension(ListBoxFiles.SelectedItems(SC - 1))
                        NF = NF & "_" & .WorkBooks(.WorkBooks.Count).Sheets(i).Name
                        ' ３２文字未満の判定
                        If Len(NF) < 32 Then
                            ' 同じシート名を使っていないことの判定
                            NF_OK = True
                            For j = 1 To .WorkBooks(1).Sheets.Count - 2
                                If NF_Array(j) = NF Then NF_OK = False
                            Next
                            If NF_OK Then .WorkBooks(1).ActiveSheet.Name = NF
                        End If
                    End If
                    ' コピーされたシート名を保存する
                    ReDim Preserve NF_Array(.WorkBooks(1).Sheets.Count)
                    NF_Array(.WorkBooks(1).Sheets.Count) = .WorkBooks(1).ActiveSheet.Name
                Next

                If ChkAutoSave.Checked Then
                Else
                    ' コピー元を閉じる(「保存しない」で終了)
                    .WorkBooks(.WorkBooks.Count).Close(False)
                End If
            Next

            ' 残った「１ページ目」を削除する
            ' 但し、このページしかない場合は、これを残す
            If .WorkBooks(1).Sheets.Count > 1 Then
                .DisplayAlerts = False
                .WorkBooks(1).Worksheets(1).Delete()
                .DisplayAlerts = True
            End If

            ' コピーした Book1(統合先)を閉じる（保存を確認する）
            .WorkBooks(1).Close()

            ' 残っているブックを閉じる（「保存しない」で終了）
            Do While .WorkBooks.Count > 0
                .WorkBooks(.WorkBooks.Count).Close(False)
            Loop

            ' Excelの終了
            .Quit()
        End With
        System.Runtime.InteropServices.Marshal.ReleaseComObject(XL)

    End Sub

    Private Sub ChkSheetNameStyle_CheckedChanged(sender As Object, e As EventArgs) Handles ChkSheetNameStyle.CheckedChanged
        If ChkSheetNameStyle.Checked Then
            MsgBox("シート名が32文字以上になる、同じシート名が存在するなど" & vbCrLf & "この機能が働かない場合があります", vbOKOnly + vbInformation, "注意")
        End If
    End Sub

    Private Sub ListBoxFiles_DragEnter(sender As Object, e As DragEventArgs) Handles ListBoxFiles.DragEnter
        ' 格納されているデータの形式を確認する
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            ' ドラッグ中のファイルやディレクトリの取得
            Dim drags() As String = _
                  CType(e.Data.GetData(DataFormats.FileDrop), String())

            For Each d As String In drags
                If Not System.IO.File.Exists(d) Then
                    ' ファイル以外であればイベント・ハンドラを抜ける
                    Return
                End If
            Next

            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub ListBoxFiles_DragDrop(sender As Object, e As DragEventArgs) Handles ListBoxFiles.DragDrop
        ' 格納されているデータを文字列型配列に変換
        Dim files() As String = CType(e.Data.GetData(DataFormats.FileDrop, False), String())
        ' ドロップされたファイル名をソートする
        Array.Sort(files)

        With ListBoxFiles
            .BeginUpdate()
            '.Items.Clear()
            .Items.AddRange(files)
            .EndUpdate()
        End With

    End Sub

    Private Sub BtnFileSelect_Click(sender As Object, e As EventArgs) Handles BtnFileSelect.Click
        Dim i As Integer
        'OpenFileDialogクラスのインスタンスを作成
        Dim ofd As New OpenFileDialog()
        '複数ファイルを開けるようにする
        ofd.Multiselect = True
        'はじめのファイル名を指定する
        ofd.FileName = ""
        'はじめに表示されるフォルダを指定する
        '指定しない（空の文字列）の時は、現在のディレクトリが表示される
        ofd.InitialDirectory = ""
        '[ファイルの種類]に表示される選択肢を指定する
        '指定しないとすべてのファイルが表示される
        ofd.Filter = _
            "EXCELファイル(*.xls;*.xlsx)|*.xls;*.xlsx" & _
            "|EXCELとテキスト(*.xls;*.xlsx;*.csv;*.txt)|*.xls;*.xlsx;*.csv;*.txt" & _
            "|すべてのファイル(*.*)|*.*"
        '[ファイルの種類]で「EXCELファイル」が選択されているようにする
        ofd.FilterIndex = 1
        'タイトルを設定する
        ofd.Title = "統合するファイルを選択してください"
        'ダイアログボックスを閉じる前に現在のディレクトリを復元するようにする
        ofd.RestoreDirectory = True

        'ダイアログを表示する
        If ofd.ShowDialog() = DialogResult.OK Then
            'OKボタンがクリックされたとき
            '選択されたファイル名を表示する
            With ListBoxFiles
                .BeginUpdate()
                .Items.Clear()
                .Items.AddRange(ofd.FileNames)
                .EndUpdate()
                For i = 1 To .Items.Count
                    .SetSelected(i - 1, True)
                Next
            End With
        End If
    End Sub

    Private Sub BtnListClear_Click(sender As Object, e As EventArgs) Handles BtnListClear.Click
        If MsgBox("一覧をクリアします", vbOKCancel + vbDefaultButton2 + MsgBoxStyle.Information, "確認") = MsgBoxResult.Ok Then
            'リストボックス初期化
            With ListBoxFiles
                .BeginUpdate()
                .Items.Clear()
                .EndUpdate()
            End With
        End If
    End Sub

    Private Sub ChkDeleteSheetName_CheckedChanged(sender As Object, e As EventArgs) Handles ChkDeleteSheetName.CheckedChanged
        If ChkDeleteSheetName.Checked Then
            TextKey.Enabled = True
        Else
            TextKey.Enabled = False
        End If
    End Sub

    Private Sub ChkAutoSave_CheckedChanged(sender As Object, e As EventArgs) Handles ChkAutoSave.CheckedChanged
        If ChkAutoSave.Checked Then
            MsgBox("Excel2010のバグ対策として全てのファイルを開いたまま処理します" & vbCrLf & "メモリ不足、速度低下などが発生する恐れがあります" & vbCrLf & "http://support.microsoft.com/kb/2278013/ja", vbOKOnly + vbInformation, "確認")
        End If
    End Sub

End Class
